package cache

import (
	"bytes"

	"github.com/dgraph-io/badger/v3"
)

func (c *CacheRepository) Get(key string) (b *bytes.Buffer, err error) {
	if err := c.cache.View(func(txn *badger.Txn) error {
		item, err := txn.Get([]byte(key))
		if err != nil {
			return err
		}
		keyBytes, err := item.ValueCopy(nil)
		if err != nil {
			return err
		}
		b = bytes.NewBuffer(keyBytes)
		return nil
	}); err != nil {
		return nil, err
	}
	return
}
